<?php
/*
 * Create ads to insert for tests. 
 * Should go through all regions categories from config and try to 
 * go thought all the necessary params for each category and insert ads.
 *
 * TODO: 
 *	- insert ads with different param values (random for each param to fit validators)
 *	- insert user data again with different names and emails (again random)
 *	- get regions/categories/params from bconf
 *	- insert ads that are not spidered and review them
 */
require_once("config.php");
require_once("bTransaction.php");
ini_set('memory_limit','1024M');

/* 
	L: number of ads to insert 
	V: Verbose inserts
	N: Not spidered
 */
$shortopts = 'l:v:n';
$options = getopt($shortopts);

$limit = 1;
if (isset($options['l'])) {
	$limit = $options['l'];
}

$verbose = false;
if (isset($options['v']))
	$verbose = true;

$spidered=true;
if (isset($options['n']))
	$spidered = false;

GLOBAL $BCONF;

function salt_password($passwd) {
	GLOBAL $BCONF, $verbose;
	$salt = '';
	for ($i = 0; $i < 16; $i++)
		$salt .= chr(mt_rand(32, 126));

	$loops = bconf_get($BCONF, "ai.passwd.stretch_loops") or 1;

	for ($i = 0; $i < $loops; $i++)
		$passwd = sha1($salt . $passwd);

	$passwd = "\$$loops\$" . $salt . $passwd;
	return $passwd;
}

function create_adcodes() {
	$trans = new bTransaction;
	$trans->add_data('verifylimit', '1');
	$trans->add_data('verify_gen', '1');
	$trans->add_data('commit', '1');
	$trans->send_command('create_adcodes');
}

function clear($verify_code) {

	$trans = new bTransaction;
	$trans->add_data('verify_code', $verify_code);
	$trans->add_data('commit', '1');
	$trans->send_command('clear');
}

$cat_keys = array_keys($category);
$reg_keys = array_keys($region);
for ($l = 1; $l <= $limit; $l++) {
	$cat_index = rand(0,count($category)-1 );
	$reg_index = rand(0, count($region)-1);

	$cat = $cat_keys[$cat_index]; 
	$cat_name = $category[$cat];
	$reg = $reg_keys[$reg_index];
	$reg_name = $region[$reg];

	$trans = new bTransaction;
	$i = 0;
	while (isset($params[$cat][$i])) {	
		$param = $params[$cat][$i++];
		if ($param == 'communes') {
			$commune_list = bconf_get($BCONF, "*.common.region." . $reg . ".commune");
			$commune_keys = array_keys($commune_list);
			$cat_param = rand($commune_keys[0], $commune_keys[0] + count($commune_list) - 1);
		}
		if (isset($$param)) {
			$cat_param = $$param;
			if (is_array($cat_param)) {
				$cat_param = rand($cat_param[0], $cat_param[1]);
			}
		}
		$trans->add_data($param, trim(@$cat_param));
	}
	if ( $spidered ) {
		$trans->add_data('link_type', 'asdf');
		$trans->add_data('external_ad_id', ++$e_ad_id);
	} else {
		create_adcodes();
		$trans->add_data('passwd', salt_password('11111'));
		$trans->add_data('pay_type', 'free');
		$trans->add_data('do_not_send_mail', '1');
		$trans->add_data('remote_addr', $ip_pool[rand(0, 19)]);
		$trans->add_data('remote_browser', 'juanitoNetBrowser');
	}
	$trans->add_data('region', $reg);
	$trans->add_data('category', $cat);
	$trans->add_data('name', 'meme');
	$trans->add_data('phone', '12341234');
	$trans->add_data('email', 'may@yes.no');
	$trans->add_data('type', 's');
	$trans->add_data('subject', substr($reg_name, 0, 20) . " " . substr($cat_name, 0 ,20) . " $l");
	$trans->add_data('body', "Autogenerated body for test purposes and such\nRegion $reg_name category $cat_name");
	$trans->add_data('company_ad', 'f');
	$trans->add_data('lang', 'es');
	$result = $trans->send_command('newad');

	if ($result['status'] != "TRANS_OK")  {
		if ($result['status'] != "TRANS_OK") 
			print_r($trans);
	} else {
		if (!$spidered)
			clear($result['paycode']) ;
	}
	unset($trans);
}
?>
